#include "botolib.h"

#define num 6000

int ox=0,oy=0,cx=0,cy=0,ro=0,gr=0,bl=0,ka=0;
float gravity=0.0f,hab=0.0f,ll=0.0f;
int px[num], py[num];
float vx[num], vy[num];
int c=0,cc=0;
int fps=0,fps2=0;
DWORD fpstimer;

void Init(void) 
{
	for(int n=0;n<num;n++)
	{
		px[n] = Rand(-32,32);
		py[n] = Rand(-20,20);
		vx[n] = Rnd()*12.0f-6.0f; 
		vy[n] = Rnd()*12.0f-6.0f; 
	}
	ox = Rnd()*260.0f-130.0f;
	oy = Rnd()*260.0f-130.0f; 
	gravity = Rnd()*16.0f+3.0f; 
}

void pgrav(void)
{ 
	for(int n = 0;n<num;n++)
	{
		float xdif = ox - px[n];
		float ydif = oy - py[n]; 
		float L = sqrtf(xdif*xdif+(ydif*ydif));
		if(ka==1)
		  L = L * gravity/Sin(L-ll);
		else if(ka==0)
		  L = L * gravity/Cos(L-ll);
		else
		  L = L *gravity/Sin((L-ll)*Cos(L-ll));
		
		if(L > 0)
		{
			vx[n] = vx[n] + xdif / L;
			vy[n] = vy[n] + ydif / L; 
			px[n] = px[n] + vx[n]; 
			py[n] = py[n] + vy[n]; 
		}
        Color(ro,gr,bl);
        Rect(px[n] + cx, py[n] + cy,3,3);
	} 
}


void BotoMain(void)
{
	Graphics(800,600,32,2);
	SetBuffer(BackBuffer());

	cx = 400; cy = 300;
	hab=Rnd()*5.0f; cc=50;
	ro=Rand(0,255);gr=Rand(0,255);bl=Rand(0,255);
	//timer =CreateTimer(50) 
	RandSeed(Millisecs());
	Init();

	while(!KeyHit(VK_ESCAPE))
	{
		PumpMessages();
		Cls();
		Color(255,255,0);
		Text(10,10,"Sturm im Wasserglas by HOT-BIT");
		Text(500,10,"FPS: "+Str(fps));
		pgrav();
		c = c + 1;
		if(c > cc)
		{
		   c = 0;
		   gravity = Rnd()*8.5f+0.5f;
		   for(int n=0;n<num;n++)
		   {
			  vx[n] = Rnd()*6.0f-3.0f; 
			  vy[n] = Rnd()*6.0f-3.0f; 
		   }
		   hab=Rnd()*5.0f;
		   ox = Rnd()*260.0f-130.0f;
		   oy = Rnd()*260.0f-130.0f; 
		   ro=Rand(0,255);gr=Rand(0,255);bl=Rand(0,255);
		   ka=Rand(0,2);
		   ll=Rnd()*360.0f;
		   cc=Rand(30,300);
		}
		fps2 = fps2 + 1;
		if(fpstimer + 1000 < Millisecs())
		{
			fps = fps2;
			fps2 = 0;
			fpstimer = Millisecs();
		}
		//WaitTimer(timer) 
		Flip();
	}
}

/*



*/